package com.my.web.controller.system;

import java.util.List;

import com.my.common.core.domain.model.LoginUser;
import com.my.quartz.domain.SysJob;
import com.my.quartz.service.ISysJobService;
import org.apache.commons.lang3.ArrayUtils;
import org.quartz.SchedulerException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import com.my.common.annotation.Log;
import com.my.common.constant.UserConstants;
import com.my.common.core.controller.BaseController;
import com.my.common.core.domain.AjaxResult;
import com.my.common.core.domain.entity.SysDept;
import com.my.common.enums.BusinessType;
import com.my.common.utils.StringUtils;
import com.my.system.service.ISysDeptService;

/**
 * 部门信息
 *
 * @author ruoyi
 */
@RestController
@RequestMapping("/system/dept")
public class SysDeptController extends BaseController
{
    @Autowired
    private ISysDeptService deptService;

    @Autowired
    private ISysJobService jobService;
//    @Autowired
//    private SyncH4ADeptTask deptTask;
    /**
     * 获取部门列表
     */
//    @PreAuthorize("@ss.hasPermi('system:dept:list')")
    @GetMapping("/list")
    public AjaxResult list(SysDept dept)
    {
        LoginUser loginUser = getLoginUser();
        if(!"1".equals(loginUser.getOrgType())){
            SysDept sysDept = deptService.selectDeptById(getOrgId());
            if(sysDept != null){
                dept.setAncestors(sysDept.getAncestors());
            }
        }
        List<SysDept> depts = deptService.selectDeptList(dept);
        return success(depts);
    }

    /**
     * 查询部门列表（排除节点）
     */
//    @PreAuthorize("@ss.hasPermi('system:dept:list')")
    @GetMapping("/list/exclude/{deptId}")
    public AjaxResult excludeChild(@PathVariable(value = "deptId", required = false) Long deptId)
    {
        SysDept dept = new SysDept();
        LoginUser loginUser = getLoginUser();
        if(!"1".equals(loginUser.getOrgType())){
            dept.setDeptId(getOrgId());
        }
        List<SysDept> depts = deptService.selectDeptList(dept);
        depts.removeIf(d -> d.getDeptId().intValue() == deptId || ArrayUtils.contains(StringUtils.split(d.getAncestors(), ","), deptId + ""));
        return success(depts);
    }

    /**
     * 根据部门编号获取详细信息
     */
//    @PreAuthorize("@ss.hasPermi('system:dept:query')")
    @GetMapping(value = "/{deptId}")
    public AjaxResult getInfo(@PathVariable Long deptId)
    {
        deptService.checkDeptDataScope(deptId);
        return success(deptService.selectDeptById(deptId));
    }

    /**
     * 获取总关、隶属海关、缉私局、事业单位四大类 机构
     * @return
     */
    @GetMapping(value = "/selectOrg")
    public AjaxResult selectOrg(){
        Long orgId = getLoginUser().getOrgId();
        return success(deptService.selectOrg(orgId));
    }
    /**
     * 获取总关、隶属海关、缉私局、事业单位四大类 机构
     * @return
     */
    @GetMapping(value = "/selectOrgAll")
    public AjaxResult selectOrgAll(){
        return success(deptService.selectOrg(null));
    }

    /**
     * 获取用户所属单位下级部门
     * @return
     */
    @GetMapping(value = "/getUserDept")
    public AjaxResult getUserDept(){
        Long orgId = getLoginUser().getOrgId();
        return success(deptService.userDept(orgId));
    }
    /**
     * 获取用户所属单位下级部门 包含父级本单位 -事由权限
     * @return
     */
    @GetMapping(value = "/getUserDeptOrg")
    public AjaxResult getUserDeptOrg(Long orgId){
        if(orgId == null){
            orgId = getLoginUser().getOrgId();
        }
        return success(deptService.userDeptOrg(orgId));
    }

    @Log(title = "部门管理", businessType = BusinessType.UPDATE )
//    @PreAuthorize("@ss.hasPermi('SYSTEM_DEPT_SYNCH')")
    @GetMapping("/deptSynch")
    public AjaxResult deptSynch() throws SchedulerException {
//        deptTask.syncH4ADeptTask();
        SysJob job = jobService.selectJobById(4l);
        jobService.run(job);
        return success(true);
    }


    /**
     * 修改部门使用标志
     */
    @Log(title = "部门管理", businessType = BusinessType.UPDATE )
    @GetMapping("/changeUseFlag")
    public AjaxResult changeUseFlag(@RequestParam("deptId") Long deptId, @RequestParam("useFlag") String useFlag) {
        return success(deptService.changeUseFlag(deptId, useFlag));
    }












    /**
     * 新增部门
     */
    @PreAuthorize("@ss.hasPermi('system:dept:add')")
    @Log(title = "部门管理", businessType = BusinessType.INSERT)
    @PostMapping
    public AjaxResult add(@Validated @RequestBody SysDept dept)
    {
        if (!deptService.checkDeptNameUnique(dept))
        {
            return error("新增部门'" + dept.getDeptName() + "'失败，部门名称已存在");
        }
        dept.setCreateBy(getUsername());
        return toAjax(deptService.insertDept(dept));
    }

    /**
     * 修改部门
     */
    @PreAuthorize("@ss.hasPermi('system:dept:edit')")
    @Log(title = "部门管理", businessType = BusinessType.UPDATE)
    @PutMapping
    public AjaxResult edit(@Validated @RequestBody SysDept dept)
    {
        Long deptId = dept.getDeptId();
        deptService.checkDeptDataScope(deptId);
        if (!deptService.checkDeptNameUnique(dept))
        {
            return error("修改部门'" + dept.getDeptName() + "'失败，部门名称已存在");
        }
        else if (dept.getParentId().equals(deptId))
        {
            return error("修改部门'" + dept.getDeptName() + "'失败，上级部门不能是自己");
        }
        else if (StringUtils.equals(UserConstants.DEPT_DISABLE, dept.getStatus()) && deptService.selectNormalChildrenDeptById(deptId) > 0)
        {
            return error("该部门包含未停用的子部门！");
        }
        dept.setUpdateBy(getUsername());
        return toAjax(deptService.updateDept(dept));
    }

    /**
     * 删除部门
     */
    @PreAuthorize("@ss.hasPermi('system:dept:remove')")
    @Log(title = "部门管理", businessType = BusinessType.DELETE)
    @DeleteMapping("/{deptId}")
    public AjaxResult remove(@PathVariable Long deptId)
    {
        if (deptService.hasChildByDeptId(deptId))
        {
            return warn("存在下级部门,不允许删除");
        }
        if (deptService.checkDeptExistUser(deptId))
        {
            return warn("部门存在用户,不允许删除");
        }
        deptService.checkDeptDataScope(deptId);
        return toAjax(deptService.deleteDeptById(deptId));
    }
}
